'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _LocaleProvider = require('./LocaleProvider');

var _LocaleProvider2 = _interopRequireDefault(_LocaleProvider);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var LocaleSwitch = (_temp2 = _class = function (_Component) {
  _inherits(LocaleSwitch, _Component);

  function LocaleSwitch() {
    var _this2 = this;

    var _temp, _this, _ret;

    _classCallCheck(this, LocaleSwitch);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.onChange = function () {
      var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(evn) {
        var _this$props, locales, onChange, onError, setLocale, onLocaleChange, translate, value, exists;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                evn.stopPropagation();

                _this$props = _this.props, locales = _this$props.locales, onChange = _this$props.onChange, onError = _this$props.onError, setLocale = _this$props.setLocale, onLocaleChange = _this$props.onLocaleChange;
                translate = _this.context.translate;
                value = evn.target.value;
                exists = locales.find(function (l) {
                  return l.locale === value;
                });

                if (exists) {
                  _context.next = 7;
                  break;
                }

                return _context.abrupt('return');

              case 7:
                if (!(setLocale && !translate.props.controlled)) {
                  _context.next = 19;
                  break;
                }

                _context.prev = 8;
                _context.next = 11;
                return translate.setLocale(value);

              case 11:
                if (onLocaleChange) {
                  onLocaleChange(value);
                }
                _context.next = 19;
                break;

              case 14:
                _context.prev = 14;
                _context.t0 = _context['catch'](8);

                if (!onError) {
                  _context.next = 19;
                  break;
                }

                onError(_context.t0);
                return _context.abrupt('return');

              case 19:

                if (onChange) {
                  onChange(value);
                }

              case 20:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this2, [[8, 14]]);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }(), _temp), _possibleConstructorReturn(_this, _ret);
  }

  LocaleSwitch.prototype.render = function render() {
    var translate = this.context.translate;
    var locale = translate.getLocale();
    var locales = this.props.locales;


    var selectProps = _extends({}, this.props);

    delete selectProps.setLocale;
    delete selectProps.locales;
    delete selectProps.onLocaleChange;

    return _react2.default.createElement(
      'select',
      _extends({}, selectProps, {
        value: locale,
        onChange: this.onChange
      }),
      locales.map(function (option, pos) {
        return _react2.default.createElement(
          'option',
          { value: option.locale, key: pos },
          option.label
        );
      })
    );
  };

  return LocaleSwitch;
}(_react.Component), _class.contextTypes = _extends({}, _LocaleProvider2.default.childContextTypes), _class.defaultProps = {
  setLocale: true
}, _class.propTypes = {
  locales: _react.PropTypes.array.isRequired,
  setLocale: _react.PropTypes.bool,
  disabled: _react.PropTypes.bool,
  name: _react.PropTypes.string,
  className: _react.PropTypes.string,
  onChange: _react.PropTypes.func,
  onLocaleChange: _react.PropTypes.func,
  onError: _react.PropTypes.func
}, _temp2);
exports.default = LocaleSwitch;